//+------------------------------------------------------------------+
//|       Four Signals TS                                            |
//+------------------------------------------------------------------+
//////////////////////////////////////////////////////////////////////

//************************************************************
// Input parameters
//************************************************************
extern int AppliedPrice = 1;
// Shaff parameters
extern int MAShort = 15;
extern int MALong = 40;
extern int Cycle = 7;
extern double Shaff_Limit = 5.0;
// Hull parameters
extern int HullPeriod = 10;
extern double Hull_Limit = 0.01;
// TEMA parameters
extern int TEMAPeriod = 25;
extern double TEMA_Limit = 0.01;
// T3 parameters
extern int T3Period = 20;
extern double T3_Limit = 0.01;

//Order manager parameters
extern int MyMagic = 222222;
extern double MyLts = 0.1;
extern int MaxDelay = 1; 
//extern int IniTrade = 0;
extern int IniStplss = 999;  
extern int ProfTrgt = 999; 
extern double ProfFctr = 1.0; 

//************************************************************
// Public vars
//************************************************************
double MomCount[99];
// Shaff vars
double Shaff[99];
double MCD, LLV, HHV, MA_Short, MA_Long, ST, smconst;
bool check_begin=false;
bool check_begin_MA=false;
int n, s, Shaff_strt, oldstrt;
double MA, OldShaff, ActShaff, sum;
double MCD_Arr[99];
int ShaffMom[999];
int oldShaffMom;
// Hull vars
double Hull[99];
double Vector[99], Hullp, Hullsum;
int HullMom[999];
int oldHullMom;
int Method, Hull_strt, j;
// TEMA vars
double EMA[99], DEMA[99], TEMA[99];
int TEMAMom[999];
int oldTEMAMom;
// T3 vars
double Ema[99], Ema_II[99], Ema_III[99], Ema_IV[99], Ema_V[99], Ema_VI[99], T3[99];
int T3Mom[999];
int oldT3Mom;
double P1, P2, P3, P4, square_PL, cube_PL, PhaseLag;

// Common vars
int pos, Barstocalc, stol, ltos;
int myind, oldind, momcount, oldmom;
double ActualProf, MaxProf, Tkprft;
int Index, Delay, Inibitor;
string ActualTrade = "No_Trade";
int MyOrder = 0;
int err = 0;
datetime ActTime;
datetime Last;

void init()
{
   ArraySetAsSeries(EMA,true);
   ArraySetAsSeries(DEMA,true);
//   ArraySetAsSeries(TEMA,true);
   ArraySetAsSeries(Ema,true);
   ArraySetAsSeries(Ema_II,true);
   ArraySetAsSeries(Ema_III,true);
   ArraySetAsSeries(Ema_IV,true);
   ArraySetAsSeries(Ema_V,true);
   ArraySetAsSeries(Ema_VI,true);

   oldmom = 0;
   oldind = 1;
   stol = 1;
   ltos = 1;
   Barstocalc = 99-1;
   
   // Shaff ini
   oldstrt = iBarShift( NULL, 0, Time[99], false);
   Shaff[99] = 50.0;
   oldShaffMom = 1;
   double a = 1+Cycle/2;
   smconst = 2/a;

   // Hull ini
   Method = 3;
   Hull[99] = Open[99];
   oldHullMom = 1;

   // TEMA ini
   TEMA[99] = Open[99];
   oldTEMAMom = 1;

   // T3 ini
   PhaseLag = 0.7;
   square_PL = PhaseLag * PhaseLag; 
   cube_PL = PhaseLag * PhaseLag * PhaseLag;
   P1 = - cube_PL;
   P2 = 3 * square_PL + 3 * cube_PL;
   P3 = - 6 * square_PL - 3 * cube_PL - 3 * PhaseLag;
   P4 = 3 * square_PL + cube_PL + 3 * PhaseLag + 1;
   T3[99] = Open[99];
   oldT3Mom = 1;
  
   // Order manager ini
   oldind = 1;
   ActTime = Time[1];
   ActualTrade = "No_Trade";
   Delay = 0;
   Inibitor = 0;
   Tkprft = -IniStplss;
   ActualProf = 0;
   MaxProf = 0;
     
   return;
}

void deinit()
{
   Comment("");
   return;
}

void start()
{
   //---- check for history and trading
   if(IsTradeAllowed()==false) // standard ver
   {
      Print ("Trade is not allowed");
      return;
   }

   // --- Check for trading Time
//   double acthour = TimeHour(TimeCurrent());
//   if (acthour<4 || acthour>22) 
//   {
//      Comment(acthour,"...It is not trading time ");
//      if (ActualTrade == "Long_Trade") OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),3);
//      if (ActualTrade == "Short_Trade") OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),3);
//      return;
//   }
   
   Index = Index_Calc();
   ActualTrade = Trade_Calc();
   ActualProf = Prof_Calc();
   if (ActualTrade  == "No_Trade")
   {
       Tkprft = -IniStplss;
       ActualProf = 0;
       MaxProf = 0;
   }
   if (ActualProf >= MaxProf) MaxProf = ActualProf;
   if (MaxProf >= ProfTrgt) Tkprft = MaxProf * ProfFctr;
   Comment(ActualTrade," at ",Index," gain ",ActualProf," tkprft ",Tkprft," Inibit ",Inibitor);

   // Take profit || Stop loss
   if (ActualTrade == "Long_Trade" && ActualProf <= Tkprft)
   {
      OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),3);
      Sleep(1000);
      Tkprft = -IniStplss;
      ActualProf = 0;
      MaxProf = 0;
      Inibitor = 1;
      Delay = MaxDelay;
      return;
   }
   if (ActualTrade == "Short_Trade" && ActualProf <= Tkprft)
   {
      OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),3);
      Sleep(1000);
      Tkprft = -IniStplss;
      ActualProf = 0;
      MaxProf = 0;
      Inibitor = -1;
      Delay = MaxDelay;
      return;
   }

   // Force reversal when index change
//   if (Delay > 0 && Index > 0 && ActualTrade == "Short_Trade") Delay = 0;
//   if (Delay > 0 && Index < 0 && ActualTrade == "Long_Trade") Delay = 0;
   
   //Waiting for the next chandle
   datetime now = Time[0];
   if (now == ActTime && Delay > 0)
   {
      ActualTrade = Trade_Calc();
      Comment(ActualTrade," at ",Index," gain ",ActualProf," tkprft ",Tkprft," Inibit ",Inibitor," Delay ",Delay," Waiting next chandle ...");
      return;
   }
   if(Delay > 0)
   {
      ActTime = Time[0];
      Delay -= 1;
      return;
   }
   // else Inibitor = 0;

   // Trade
   if (Index < 0 && ActualTrade != "Short_Trade")
   {
      if (ActualTrade == "Long_Trade") 
      {
         OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),3);
         Sleep(1000);
         ActualTrade = "No_Trade";
         Tkprft = -IniStplss;
         ActualProf = 0;
         MaxProf = 0;
      }
      if (Inibitor > -1)
      {
         GoforSell();
         Delay = MaxDelay;
         Inibitor = 0;
         Tkprft = -IniStplss;
         ActualProf = 0;
         MaxProf = 0;
         ActualTrade = "Short_Trade";
      }
      Comment(ActualTrade," at ",Index," gain ",ActualProf," tkprft ",Tkprft," Inibit ",Inibitor);
      return;
   }

   if (Index > 0 && ActualTrade != "Long_Trade")
   {
      if (ActualTrade == "Short_Trade") 
      {
         OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),3);
         Sleep(1000);
         ActualTrade = "No_Trade";
         Tkprft = -IniStplss;
         ActualProf = 0;
         MaxProf = 0;
      }
      if (Inibitor < 1)
      {
         GoforBuy();
         Delay = MaxDelay;
         Inibitor = 0;
         Tkprft = -IniStplss;
         ActualProf = 0;
         MaxProf = 0;
         ActualTrade = "Long_Trade";
      }
      Comment(ActualTrade," at ",Index," gain ",ActualProf," tkprft ",Tkprft," Inibit ",Inibitor);
      return;
   }
   
   // otherwise do nothing
   Comment(ActualTrade," at ",Index," gain ",ActualProf," tkprft ",Tkprft," Inibit ",Inibitor);
   return;
  }
//+--- end start function -------------------------------------------+

//+------------------------------------------------------------------+
//| expert actual trade calculation function                         |
//+------------------------------------------------------------------+
string Trade_Calc()
  {
  string TradeType="No_Trade";
  for(int i=0;i<OrdersTotal();i++)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)
         {
            Print("OrderSelect returned the error of ",GetLastError());
            break;
         }
         else
         {
            int mgc = OrderMagicNumber();
            if (mgc == MyMagic)
            {  
               MyOrder=OrderTicket();
               if(OrderType()==OP_BUY) TradeType="Long_Trade";
               if(OrderType()==OP_SELL) TradeType="Short_Trade";
            }
         }
      }
return(TradeType);
}

//+------------------------------------------------------------------+
//| expert go for long trading                                       |
//+------------------------------------------------------------------+
int GoforBuy()
{
   //if (ActualTrade=="Short_Trade") OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits),3);
   MyOrder = -999;
   Print (" LONG trade will start");
   while(MyOrder<=0)
   {
      double buyprice = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),Digits);
//      MyOrder=OrderSend(Symbol(),OP_BUY,MyLts,buyprice,3,buyprice-999*Point,buyprice+999*Point,"",MyMagic,0);
      MyOrder=OrderSend(Symbol(),OP_BUY,MyLts,buyprice,3,0,0,"",MyMagic,0);
      if(MyOrder<0) Alert("OrderSend failed with error #",GetLastError());
      Sleep(1000);
   }
   return(MyOrder);
}

//+------------------------------------------------------------------+
//| expert go for short trading                                       |
//+------------------------------------------------------------------+
int GoforSell()
{
   //if (ActualTrade=="Long_Trade") OrderClose(MyOrder,MyLts,NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits),3);
   MyOrder = -999;
   Print (" SHORT trade will start");
   while(MyOrder<=0)
   {
      double selprice = NormalizeDouble(MarketInfo(Symbol(),MODE_BID),Digits);
//      MyOrder=OrderSend(Symbol(),OP_SELL,MyLts,selprice,3,selprice+999*Point,selprice-999*Point,"",MyMagic,0);
      MyOrder=OrderSend(Symbol(),OP_SELL,MyLts,selprice,3,0,0,"",MyMagic,0);
      if(MyOrder<0) Alert("OrderSend failed with error #",GetLastError());
      Sleep(1000);
   }
   return(MyOrder);
}

//+------------------------------------------------------------------+
//| expert actual profit calculation function                         |
//+------------------------------------------------------------------+
double Prof_Calc()
{
  double prof = 0.0; 
  if(OrderSelect(MyOrder, SELECT_BY_TICKET)==true)
  {
     prof = OrderProfit();
  }
  else Print("OrderSelect returned the error of ",GetLastError());
  
return(prof);
}

//+------------------------------------------------------------------+
//| Index calculation               |
//+------------------------------------------------------------------+
int Index_Calc()
{
   // ---------------------------------------------------------Shaff
   ActShaff = Shaff[Barstocalc+1];
   for( pos=Barstocalc; pos>=0; pos-- )
   {  
      Shaff_strt = iBarShift( NULL, 0, Time[pos], false);
      if(Shaff_strt != oldstrt) 
      {  
         OldShaff = Shaff[pos+1];
         ActShaff = Shaff_Calc();
         oldstrt = Shaff_strt;
      }
      Shaff[pos] = ActShaff;
      ShaffMom[pos] = oldShaffMom;
      if((Shaff[pos] - Shaff[pos+1]) < -Shaff_Limit) ShaffMom[pos] = -1;
      if((Shaff[pos] - Shaff[pos+1]) > Shaff_Limit) ShaffMom[pos] = 1;
      oldShaffMom = ShaffMom[pos];
   }

   // ----------------------------------------------------------Hull
   for( pos=Barstocalc; pos>=0; pos-- )
   { 
      //Hull[pos] = Hull[pos+1];
      Hull_strt = iBarShift( NULL, 0, Time[pos], false);
      Hullp = MathFloor(MathSqrt(HullPeriod));
      Hullsum=0;
      for(j=Hull_strt; j<Hull_strt+Hullp; j++)
      {
         Vector[j] = 2 * iMA(NULL,0,HullPeriod/2,0,Method,AppliedPrice,j) - iMA(NULL,0,HullPeriod,0,Method,AppliedPrice,j);
         Hullsum += Vector[j]; 
      }
      Hull[pos] = Hullsum/Hullp;
      HullMom[pos] = oldHullMom;
      if(Hull[pos+1] == 0) continue; //protezione contro zero divide
      if(100 * ((Hull[pos] - Hull[pos+1]) / Hull[pos+1]) < -Hull_Limit) HullMom[pos] = -1;
      if(100 * ((Hull[pos] - Hull[pos+1]) / Hull[pos+1]) > Hull_Limit) HullMom[pos] = 1;
      oldHullMom = HullMom[pos];
   } 

   // ------------------------------------------------------------TEMA
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      EMA[pos] = iMA(NULL,0,TEMAPeriod,0,MODE_EMA,AppliedPrice,pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      DEMA[pos] = iMAOnArray( EMA, 0, TEMAPeriod, 0, MODE_EMA, pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      TEMA[pos] = iMAOnArray( DEMA, 0, TEMAPeriod, 0, MODE_EMA, pos) + 3*EMA[pos] - 3*DEMA[pos];
      TEMAMom[pos] = oldTEMAMom;
      if(TEMA[pos+1] == 0) continue; //protezione contro zero divide
      if(100 * ((TEMA[pos] - TEMA[pos+1]) / TEMA[pos+1]) < -TEMA_Limit) TEMAMom[pos] = -1;
      if(100 * ((TEMA[pos] - TEMA[pos+1]) / TEMA[pos+1]) > TEMA_Limit) TEMAMom[pos] = 1;
      oldTEMAMom = TEMAMom[pos];
   }

   // ------------------------------------------------------------ T3
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      Ema[pos] = iMA(NULL,0,T3Period,0,MODE_EMA,AppliedPrice,pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      Ema_II[pos] = iMAOnArray( Ema, 0, T3Period, 0, MODE_EMA, pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      Ema_III[pos] = iMAOnArray( Ema_II, 0, T3Period, 0, MODE_EMA, pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      Ema_IV[pos] = iMAOnArray( Ema_III, 0, T3Period, 0, MODE_EMA, pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      Ema_V[pos] = iMAOnArray( Ema_IV, 0, T3Period, 0, MODE_EMA, pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      Ema_VI[pos] = iMAOnArray( Ema_V, 0, T3Period, 0, MODE_EMA, pos);
   }
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      T3[pos] = P1 * Ema_VI[pos] + P2 * Ema_V[pos] + P3 * Ema_IV[pos] + P4 * Ema_III[pos];
      T3Mom[pos] = oldT3Mom;
      if(T3[pos+1] == 0) continue; //protezione contro zero divide
      if(100 * ((T3[pos] - T3[pos+1]) / T3[pos+1]) < -T3_Limit) T3Mom[pos] = -1;
      if(100 * ((T3[pos] - T3[pos+1]) / T3[pos+1]) > T3_Limit) T3Mom[pos] = 1;
      oldT3Mom = T3Mom[pos];
   }

   // Index
   for( pos=Barstocalc; pos>=0; pos-- )
   {
      myind = oldind; 
      MomCount[pos] = ShaffMom[pos] + HullMom[pos] + TEMAMom[pos] + T3Mom[pos]; 
      
      // -----------------------------------------------------------------da long a short
      if((oldind > 0) && (MomCount[pos+1] == 4) && (MomCount[pos] < 4)) // da +4 in giu' 
      {  
         myind = -5;
         oldind = myind;
         continue;
      }
      if((oldind > 0) && (MomCount[pos+1] == 2) && (MomCount[pos] < 0)) // da +2 a -2 almeno
      {  
         myind = -5;
         oldind = myind;
         continue;
      }
      if((oldind > 0) && (MomCount[pos+1] == 0) && (MomCount[pos] < -2)) // da 0 a -4
      {  
         myind = -5;
         oldind = myind;
         continue;
      }

      // -----------------------------------------------------------------da short a short
      
      if((oldind < 0) && (MomCount[pos+1] == -4) && (MomCount[pos] > -4)) //da -4 in su 
      {  
         myind = 5;
         oldind = myind;
         continue;
      }
      if((oldind < 0) && (MomCount[pos+1] == -2) && (MomCount[pos] > 0)) // da -2 a +2 almeno
      {  
         myind = 5;
         oldind = myind;
         continue;
      }
      if((oldind < 0) && (MomCount[pos+1] == 0) && (MomCount[pos] > 2)) // da 0 a +4
      {  
         myind = 5;
         oldind = myind;
         continue;
      }

      oldind = myind;
   }

   return(myind);
}

/////////////////////////////////////////
double Shaff_Calc()
{
   LLV=0;
   HHV=0;
   ST=0;
   check_begin = false;
   check_begin_MA = false;
   n = 1;
   s = 1;

//Print(pos," ",TimeHour(Time[pos])," ",Tmfrm," ",Shaff_strt," ",OldShaff);

   for( int shft=MALong; shft>=0; shft-- )
   {
      MA_Short=iMA(NULL,0,MAShort,0,MODE_EMA,AppliedPrice,shft+Shaff_strt);
      MA_Long=iMA(NULL,0,MALong,0,MODE_EMA,AppliedPrice,shft+Shaff_strt);
      MCD_Arr[n] = MA_Short - MA_Long;
      MCD = MA_Short - MA_Long;
      
      if (n >= Cycle )
      {
         n = 1;
         check_begin = true;
      }
      else n = n + 1;
      
      if (check_begin)
      {
         for (int i = 1 ;i<=Cycle; i++)
         {
            if (i == 1) LLV = MCD_Arr[i];
            else
            if( LLV > MCD_Arr[i] ) LLV = MCD_Arr[i];
 
            if (i == 1 ) HHV = MCD_Arr[i];
            else
            if( HHV < MCD_Arr[i]) HHV = MCD_Arr[i];
         }
         double dv = HHV - LLV;
         ST = 0;
         if(dv != 0) ST = ((MCD - LLV)/dv)*100 + 0.01;
//         ST = ((MCD - LLV)/(HHV - LLV))*100 + 0.01;
         s = s + 1;
         if (s >= (Cycle)/2)
         {
            s = 1;
            check_begin_MA = true;
         }
      }
      else ST = 0;
      
//Print(pos," ",n," ",MCD," ",LLV," ",HHV," ",ST);

      if (check_begin_MA )
      {
         MA = smconst * (ST - OldShaff) + OldShaff;
      }
   } 
   if(MA > 100) MA=100;

   return(MA);
}


